#!/bin/bash
here="`dirname \"$0\"`"
cd "$here" || exit 1

cd "stories"

printf "\nPlease enter the number that corresponds to the story that you would like to create an app for:\n\n"
select name in */; do test -n "$name" && break; printf ">>> That was an invalid selection. Please try another one.\n\n"; done

cd ../

title="\nExcellent choice! Now, please enter the number that corresponds to the type of app that you would like to create:\n\n"
prompt="Pick an option:"
options=("website" "android" "iOS" "All Three")

printf "$title"
PS3="#? "
select opt in "${options[@]}" "Cancel"; do

case "$REPLY" in

1 )
    rm -rf stories/"$name"output/;
    mkdir -p stories/"$name"output/web;
    mkdir -p stories/"$name"output/web/img;
    mkdir -p stories/"$name"output/web/music;
    mkdir -p stories/"$name"output/web/js;
    python engine/scripts/create.py "$name";
    cp stories/"$name"img/* stories/"$name"output/web/img/;
    cp stories/"$name"music/* stories/"$name"output/web/music/;
    printf "\nCongratulations! You have successfully created a website for '$name' within the your story's 'output/web' folder!\n\n";
;;
2 )
    rm -rf stories/"$name"output/;
    mkdir -p stories/"$name"output/web;
    mkdir -p stories/"$name"output/web/img;
    mkdir -p stories/"$name"output/web/music;
    mkdir -p stories/"$name"output/web/js;
    mkdir -p stories/"$name"output/android;
    python engine/scripts/create.py "$name";
    cp stories/"$name"img/* stories/"$name"output/web/img/;
    cp stories/"$name"music/* stories/"$name"output/web/music/;
    cp -r engine/android/ stories/"$name"output/android/;
    cp stories/"$name"output/web/website.html stories/"$name"output/android/assets/www/index.html;
    cp stories/"$name"output/web/js/website.js stories/"$name"output/android/assets/www/js/website.js;
    cp stories/"$name"img/* stories/"$name"output/android/assets/www/img/;
    cp stories/"$name"music/* stories/"$name"output/android/assets/www/music/;
    rm -rf stories/"$name"output/web/;
    printf "\nCongratulations! You have successfully created an android app for '$name' within the your story's 'output/android' folder!\n\n";
;;
3 )
    rm -rf stories/"$name"output/;
    mkdir -p stories/"$name"output/web;
    mkdir -p stories/"$name"output/web/img;
    mkdir -p stories/"$name"output/web/music;
    mkdir -p stories/"$name"output/web/js;
    mkdir -p stories/"$name"output/ios;
    python engine/scripts/create.py "$name";
    cp stories/"$name"img/* stories/"$name"output/web/img/;
    cp stories/"$name"music/* stories/"$name"output/web/music/;
    cp -r engine/ios/ stories/"$name"output/ios/;
    cp stories/"$name"output/web/website.html stories/"$name"output/ios/www/index.html;
    cp stories/"$name"output/web/js/website.js stories/"$name"output/ios/www/js/website.js;
    cp stories/"$name"img/* stories/"$name"output/ios/www/img/;
    cp stories/"$name"music/* stories/"$name"output/ios/www/music/;
    rm -rf stories/"$name"output/web/;
    printf "\nCongratulations! You have successfully created an iOS app for '$name' within the your story's 'output/ios' folder!\n\n";
;;
4 )
    rm -rf stories/"$name"output/;
    mkdir -p stories/"$name"output/web;
    mkdir -p stories/"$name"output/web/img;
    mkdir -p stories/"$name"output/web/music;
    mkdir -p stories/"$name"output/web/js;
    mkdir -p stories/"$name"output/android;
    mkdir -p stories/"$name"output/ios;
    python engine/scripts/create.py "$name";
    cp stories/"$name"img/* stories/"$name"output/web/img/;
    cp stories/"$name"music/* stories/"$name"output/web/music/;
    cp -r engine/android/ stories/"$name"output/android/;
    cp stories/"$name"output/web/website.html stories/"$name"output/android/assets/www/index.html;
    cp stories/"$name"output/web/js/website.js stories/"$name"output/android/assets/www/js/website.js;
    cp stories/"$name"img/* stories/"$name"output/android/assets/www/img/;
    cp stories/"$name"music/* stories/"$name"output/android/assets/www/music/;
    cp -r engine/ios/ stories/"$name"output/ios/;
    cp stories/"$name"output/web/website.html stories/"$name"output/ios/www/index.html;
    cp stories/"$name"output/web/js/website.js stories/"$name"output/ios/www/js/website.js;
    cp stories/"$name"img/* stories/"$name"output/ios/www/img/;
    cp stories/"$name"music/* stories/"$name"output/ios/www/music/;
    printf "\nCongratulations! You have successfully created a web, android, and iOS app for '$name' within the your story's 'output' folder!\n\n";
;;

$(( ${#options[@]}+1 )) ) printf "\nGoodbye!\n"; break;;
*) printf ">>> That was an invalid selection. Please try another one.\n\n";continue;;

esac
break;

done
