#!/bin/bash
here="`dirname \"$0\"`"
cd "$here" || exit 1

name="$(osascript -e 'Tell application "System Events" to display dialog "Please enter a name for your new story:" default answer ""' -e 'text returned of result' 2>/dev/null)"
if [ $? -ne 0 ]; then
    # The user pressed Cancel
    exit 1 # exit with an error status
elif [ -z "$name" ]; then
    # The user left the project name blank
    osascript -e 'Tell application "System Events" to display alert "You did not enter a name for your new story. Please try again." as warning'
    exit 1 # exit with an error status
fi

mkdir -p stories/"$name";
mkdir -p stories/"$name"/img;
mkdir -p stories/"$name"/music;

cp engine/tools/blank.wav stories/"$name"/music/blank.wav;
cp engine/tools/blank.jpg stories/"$name"/img/blank.jpg;
cp engine/tools/blank.png stories/"$name"/img/blank.png;
cp engine/tools/blank.txt stories/"$name"/code.txt;

echo "Successfully created folder system for '$name' within the 'stories' folder.";