// This creates a random session ID,
function s4() {
  return Math.floor((1 + Math.random()) * 0x10000)
             .toString(16)
             .substring(1);
};

// This creates a random session ID.
function guid() {
  return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
         s4() + '-' + s4() + s4() + s4();
}

// This creates a random session ID.
var sessionId = guid()

var numRows = 0;
var numCols = 0;

// This creates a Logging Data object with several properties.
var LoggingData =
{
  startTime : new Date().getTime(),
  data : sessionId + "&width=0&height=0&",

  sendData : function()
  {
    var img = new Image();

    img.src = 'http://162.243.200.130/data?' + this.data;  
    this.data = sessionId + "&width=" + ConstantValues.canvasWidth + "&height=" + 
            ConstantValues.canvasHeight + "&";
  },

  addPoint : function(x,y)
  {
    this.data = this.data + this.addCurrentTimeInterval(this.convertPointToString(x,y)) + "&";
    if(this.data.length > 1900)
      this.sendData();
  },

  addCurrentTimeInterval : function(pointStrong)
  {
    var timeElapsed = new Date().getTime();
    timeElapsed = timeElapsed - this.startTime;
    return timeElapsed + "," + pointStrong;
  },

  convertPointToString : function(x,y)
  {
    return "["+x+","+y+"]";
  },

  sceneChange : function(currentSceneName)
  {
    this.data = this.data + "newScene=" + currentSceneName + "&";
  },

  audioChange : function(currentAudio)
  {
    this.data = this.data + "newAudio=" + currentAudio + "&";
  },

  mouseUpTrack : function()
  {
    this.data = this.data + this.addCurrentTimeInterval("mouseUp&");
  }
}

var initHandlers = function()
{
  document.onmousedown = MouseTouchHandler.mouseStart;
  document.onmousemove = MouseTouchHandler.mouseMove;
  document.onmouseup = MouseTouchHandler.mouseFinish;
  document.addEventListener("touchstart",MouseTouchHandler.touchStart, false);
  document.addEventListener("touchmove",MouseTouchHandler.touchMove, false);
  document.addEventListener("touchend",MouseTouchHandler.touchEnd, false);
  document.addEventListener("touchcancel",MouseTouchHandler.touchEnd, false);
}

var ConstantValues =
{
  canvasHeight : 0,
  canvasWidth : 0,
  //Need a way to ensure that naviBarHeight is always adjusting
  innerHeight : window.innerHeight,
  innerWidth : window.innerWidth,

  // This function creates the 4 by 3 grid.
  setAllValues : function()
  {
    this.n_widthOfRevealMax = Math.max(this.canvasWidth, this.canvasHeight)/numCols;
    this.n_widthOfGrid = Math.floor(this.canvasWidth/numCols);
    this.n_heightOfGrid  = Math.floor(this.canvasHeight/numRows);
    this.n_revealInterval = 1;
    this.bodyObject = $('bodyOfPage');
    //Had to make it margin to make the background color black as margin doesn't do that
    this.bodyPaddingTop = (this.innerHeight - this.canvasHeight)/2;
    this.bodyPaddingLeft = (this.innerWidth - this.canvasWidth)/2;
    this.bodyObject.style.paddingTop = Math.ceil(this.bodyPaddingTop) + "px";
    this.bodyObject.style.paddingBottom = Math.ceil(this.bodyPaddingTop) + "px";
    this.bodyObject.style.paddingLeft = Math.ceil(this.bodyPaddingLeft) + "px";
  }
}

var ImageEnums =
{
  s_backGroundImageName : 'backImage',
  s_canvasName : 'myCanvas'
}

//A hidden image object and its constructor
function HiddenImage(x, y, imageName)
{
  this.hiddenImageLocationX = x;
  this.hiddenImageLocationY = y;
  this.hiddenImage = imageName;
  this.hiddenImageSeen = false;
}

// This function is intended to determine the number of rows and columns.
function SetGrid(c, r)
{
  numCols = c;
  numRows = r;
}

function SceneInfo()
{
  this.sceneName = '';
  this.sceneNumber = '';
  this.sceneBackgroundImg = '';
  this.sceneAudio = '';
  this.sceneBlurredImg = '';
  this.sceneBlurred = true;
}

function StoryLogic()
{
  this.sceneNumber = 0;
  this.logicId = '';
  this.initiallyActive = false;
  this.isActive = false;
  this.triggerLogicLocation = [0,0];
  this.triggerActivated = true; //false
  this.listOfCurrentImages = [];
  this.listOfNextLogicOn = [];
  this.listOfNextLogicOff = [];
  this.listOfDependentLogic = [];
  this.orderImportant = false;
  this.nextScene = false;
  this.transitionImage = '';
  this.transitionDirection = 'up';
  this.audioForLogic = false;
}

var StoryAudio =
{
  currentAudio : new Audio(),
  changeAudio : function(newAudioFileName) {
    //If there is no new fileName keep the same audio
    if(newAudioFileName == false)
    {
      return;
    }
    this.currentAudio.pause();
    //If the audio file name is none then it should make no sounds
    if(newAudioFileName.indexOf("None") != -1) 
    {
      this.currentAudio = new Audio();
    }
    else
    {
      LoggingData.audioChange(newAudioFileName);
      this.currentAudio = new Audio(newAudioFileName);
      this.currentAudio.loop = true;
      this.currentAudio.play();
    }
  }
}

var ListOfLogics = [];

var TransitionVariables =
{
  //When transitioning use the transition image
  //after that use the next image with the transition image
  transitionImage : '',
  showTransition : true,
  direction : '',
  timer : undefined,
  timerTime : 10,
  //TODO: Set the intervals depending on the size of the transition image
  intervals : 100,
  counter : 1,
  currentlyChangingScene : false
}

var DrawingVariables =
{
  canvas : {'temp':null, 'revealing': null, 'draw':null, 
    'blurringArray': new Array(ConstantValues.n_revealInterval),
          'blurringArrayMinMax' : new Array(ConstantValues.n_revealInterval)},
  rotationValue : 0,
  previousX : 0,
  previousY : 0,
  currentX : 0,
  currentY : 0,
  n_widthOfReveal : 1,
  // Is a scene info object that will help with the transition
  currentScene : '',
  nextScene : '',
  isInTransition : false,
  mapOfScenes : {}
}

var MouseTouchHandler =
{
  touchDistance : 50,
  mouseStart: function(e)
  {
    UnblurHandling.handleStart(e.pageX, e.pageY);
  },

  mouseMove : function(e)
  {
    UnblurHandling.handleMove(e.pageX, e.pageY);
  },

  mouseFinish : function(e)
  {
    UnblurHandling.handleFinish();
  },

  touchStart : function(e)
  {
    e.preventDefault();
    var touchList = e.changedTouches;
    if (touchList.length == 1)
      UnblurHandling.handleStart(touchList[0].pageX, touchList[0].pageY-50);
  },

  touchMove : function(e)
  {
    e.preventDefault();
    var touchList = e.changedTouches;
    if (touchList.length == 1)
      UnblurHandling.handleMove(touchList[0].pageX, touchList[0].pageY-50);
  },

  touchEnd : function(e)
  {
    e.preventDefault();
    UnblurHandling.handleFinish();
  }
}

var UnblurHandling =
{
  mouseDown : false,

  handleStart : function(x, y)
  {
    x = x - ConstantValues.bodyPaddingLeft;
    y = y - ConstantValues.bodyPaddingTop;
    this.mouseDown = true;

    LoggingData.addPoint(x,y);

    DrawingVariables.currentX = x;
    DrawingVariables.currentY = y;
  },

  handleMove : function(x, y)
  {
    if(this.mouseDown)
    {
      x = x - ConstantValues.bodyPaddingLeft;
      y = y - ConstantValues.bodyPaddingTop;

      LoggingData.addPoint(x,y);
      
      RevealPartOfImage.unBlurDraggedArea(x,y,true,
        DrawingVariables.canvas.blurringArray[DrawingVariables.rotationValue]);
      DrawingVariables.currentX = x;
      DrawingVariables.currentY = y;
    }
  },

  handleFinish : function()
  {
    LoggingData.mouseUpTrack();

    this.mouseDown = false;
    DrawingVariables.currentX = 0;
    DrawingVariables.currentY = 0;
    DrawingVariables.n_widthOfReveal = 1;
  }
}

var BlurringImage = 
{
  normalizeNumber : function(theNumber)
  {
    if(theNumber > 255)
      return 255;
    else if (theNumber < 0)
      return 0;
    else
      return theNumber;
  },

  blurHorizontally : function(pixels, blurredImage, pixelCounter, width)
  {
      var r = pixels[pixelCounter];
      var g = pixels[pixelCounter + 1];
      var b = pixels[pixelCounter + 2];
      var a = pixels[pixelCounter + 3];

      var blurRadius = 4;
      // Made the width of the blur 15
      var pixelsWithinRadius = 0;
      for(var counter = 1; counter < blurRadius; counter ++)
      {
        if(this.normalizeHorizontalIdx(pixelCounter, counter, width))
        {
          pixelsWithinRadius ++;
          r = r + pixels[this.normalizeHorizontalIdx(pixelCounter, counter, width)];
          g = g + pixels[this.normalizeHorizontalIdx(pixelCounter+1, counter, width)];
          b = b + pixels[this.normalizeHorizontalIdx(pixelCounter+2, counter, width)];
          a = a + pixels[this.normalizeHorizontalIdx(pixelCounter+3, counter, width)];
        }
        if(this.normalizeHorizontalIdx(pixelCounter, -counter, width))
        {
          pixelsWithinRadius ++;
          r = r + pixels[this.normalizeHorizontalIdx(pixelCounter, -counter, width)];
          g = g + pixels[this.normalizeHorizontalIdx(pixelCounter+1, -counter, width)];
          b = b + pixels[this.normalizeHorizontalIdx(pixelCounter+2, -counter, width)];
          a = a + pixels[this.normalizeHorizontalIdx(pixelCounter+3, -counter, width)];
        }
      }

      blurredImage.data[pixelCounter] = this.normalizeNumber(r / (pixelsWithinRadius + 1));
      blurredImage.data[pixelCounter + 1] = this.normalizeNumber(g / (pixelsWithinRadius + 1));
      blurredImage.data[pixelCounter + 2] = this.normalizeNumber(b / (pixelsWithinRadius + 1));
      blurredImage.data[pixelCounter + 3] = this.normalizeNumber(a / (pixelsWithinRadius + 1));

      return blurredImage;
  },

  normalizeHorizontalIdx : function(horizontalIdx, blurCounter, width)
  {
    
    if(horizontalIdx%width + blurCounter*4 < 0)
      return false; 
    else if(horizontalIdx%width + blurCounter*4 > width)
      return false;
    
    return horizontalIdx + blurCounter*4;
  },

  blurVertically : function(pixels, blurredImage, pixelCounter, width, height)
  {
      var r = pixels[pixelCounter];
      var g = pixels[pixelCounter + 1];
      var b = pixels[pixelCounter + 2];
      var a = pixels[pixelCounter + 3];

      var blurRadius = 4;
      // Made the width of the blur 5
      var pixelsWithinRadius = 0;
      for(var counter = 0; counter < blurRadius; counter ++)
      {
        if(this.normalizeVerticalIdx(pixelCounter, counter, width, height))
        {
          pixelsWithinRadius ++;
          r = r + pixels[this.normalizeVerticalIdx(pixelCounter, counter, width, height)];
          g = g + pixels[this.normalizeVerticalIdx(pixelCounter+1, counter, width, height)];
          b = b + pixels[this.normalizeVerticalIdx(pixelCounter+2, counter, width, height)];
          a = a + pixels[this.normalizeVerticalIdx(pixelCounter+3, counter, width, height)];
        }
        
        if(this.normalizeVerticalIdx(pixelCounter, -counter, width, height))
        {
          pixelsWithinRadius ++;
          r = r + pixels[this.normalizeVerticalIdx(pixelCounter, -counter, width, height)];
          g = g + pixels[this.normalizeVerticalIdx(pixelCounter+1, -counter, width, height)];
          b = b + pixels[this.normalizeVerticalIdx(pixelCounter+2, -counter, width, height)];
          a = a + pixels[this.normalizeVerticalIdx(pixelCounter+3, -counter, width, height)];
        }
      }

      blurredImage.data[pixelCounter] = r / (pixelsWithinRadius + 1);
      blurredImage.data[pixelCounter + 1] = g / (pixelsWithinRadius + 1);
      blurredImage.data[pixelCounter + 2] = b / (pixelsWithinRadius + 1);
      blurredImage.data[pixelCounter + 3] = a / (pixelsWithinRadius + 1);

      return blurredImage;
  },

  normalizeVerticalIdx : function(verticalIdx, blurCounter, width, height)
  {
    if(verticalIdx/width + blurCounter < 0)
      return false;
    else if(verticalIdx/width + blurCounter > height -1)
      return false;
    
    return verticalIdx + (blurCounter*width);
  },

  getTheBlurredImage : function(originalImage)
  {
    var canvasDraw = DrawingVariables.canvas.draw;
    var tempCanvasForBlur = document.createElement('canvas');
    var tempCanvasForBlurContext = tempCanvasForBlur.getContext('2d');

    tempCanvasForBlur.width = canvasDraw.width;
    tempCanvasForBlur.height = canvasDraw.height;

    tempCanvasForBlurContext.drawImage(originalImage, 0, 0, 
          canvasDraw.width, canvasDraw.height);

    //var pixels = tempCanvasForBlurContext.getImageData(0,0,
    //        canvasDraw.width, canvasDraw.height).data;
    var pixels = canvasDraw.getContext('2d').getImageData(0,0,
            canvasDraw.width, canvasDraw.height).data;

    var blurredImage = tempCanvasForBlurContext.createImageData(canvasDraw.width,canvasDraw.height);  
    /*
    var blurredImageHorizontal = tempCanvasForBlurContext.createImageData(canvasDraw.width,canvasDraw.height);  
  
    for(var pixelCounter = 0; pixelCounter < pixels.length; pixelCounter+=4)
    {
      blurredImageHorizontal = this.blurHorizontally(pixels, blurredImageHorizontal, pixelCounter, canvasDraw.width*4);
    }
    for(var pixelCounter = 0; pixelCounter < pixels.length; pixelCounter+=4)
    {
      blurredImage = this.blurVertically(blurredImageHorizontal.data, blurredImage, pixelCounter, canvasDraw.width*4, canvasDraw.height);
    }
    for(var pixelCounter = 0; pixelCounter < pixels.length; pixelCounter+=4)
    {
      blurredImage.data[pixelCounter] = this.normalizeNumber(blurredImage.data[pixelCounter]-200);
      blurredImage.data[pixelCounter+1] = this.normalizeNumber(blurredImage.data[pixelCounter+1]-200);
      blurredImage.data[pixelCounter+2] = this.normalizeNumber(blurredImage.data[pixelCounter+2]-200);
      blurredImage.data[pixelCounter+3] = this.normalizeNumber(blurredImage.data[pixelCounter+3]-5);
    }
    */
    for(var pixelCounter = 0; pixelCounter < pixels.length; pixelCounter+=4)
    {
      blurredImage.data[pixelCounter] = this.normalizeNumber(pixels[pixelCounter]-230);
      blurredImage.data[pixelCounter+1] = this.normalizeNumber(pixels[pixelCounter+1]-230);
      blurredImage.data[pixelCounter+2] = this.normalizeNumber(pixels[pixelCounter+2]-230);
      blurredImage.data[pixelCounter+3] = this.normalizeNumber(pixels[pixelCounter+3]-30);
    }

    tempCanvasForBlurContext.putImageData(blurredImage, 0, 0);

    var returningImage = document.createElement("img");
    returningImage.src = tempCanvasForBlur.toDataURL("image/blurredBackground.png");
    return returningImage;
  }
}

var paintImage = function(isRevealingImage)
{ 
  var canvasGroup = DrawingVariables.canvas;
  var canvasGroupTempContext = canvasGroup.temp.getContext('2d');
  var canvasGroupDrawContext = canvasGroup.draw.getContext('2d');

  var displayCurrentImages = function()
  {
    for(var logicCounter = 0; logicCounter < ListOfLogics.length; logicCounter ++)
    {
      var HiddenImageLogic = ListOfLogics[logicCounter];
      if(typeof(HiddenImageLogic.listOfCurrentImages) != 'undefined' && HiddenImageLogic.isActive
          && HiddenImageLogic.triggerActivated)
      {  
        for(var hiddenImageCounter = 0; hiddenImageCounter < HiddenImageLogic.listOfCurrentImages.length; 
          hiddenImageCounter ++)
        {
          putImage(HiddenImageLogic.listOfCurrentImages[hiddenImageCounter].hiddenImageLocationX,
          HiddenImageLogic.listOfCurrentImages[hiddenImageCounter].hiddenImageLocationY,
          HiddenImageLogic.listOfCurrentImages[hiddenImageCounter].hiddenImage);
        }
      }
    }
  }

  var putImage = function(x,y,image)
  {
    canvasGroupTempContext.globalCompositeOperation = 'source-atop';
    canvasGroupTempContext.drawImage(image,ConstantValues.n_widthOfGrid * x, ConstantValues.n_heightOfGrid * y,
        ConstantValues.n_widthOfGrid, ConstantValues.n_heightOfGrid);
  }
  

  var ifTransitionOver = function()
  {
    if(TransitionVariables.counter >= TransitionVariables.intervals && TransitionVariables.showTransition == false)
    {
      DrawingVariables.isInTransition = false;
      TransitionVariables.showTransition = true;
      TransitionVariables.counter = 1;
      window.clearInterval(TransitionVariables.timer);
      //Change the transition to a new scene
      DrawingVariables.currentScene = DrawingVariables.nextScene;
      
      LoggingData.sceneChange(DrawingVariables.currentScene.sceneName);

      //This is where the audio is changed as well
      StoryAudio.changeAudio(DrawingVariables.currentScene.sceneAudio);
      BlurStory.turnOnAllCurrentLogic();

      /*
      if(DrawingVariables.currentScene.sceneBlurred)
      {
        DrawingVariables.currentScene.sceneBlurredImg = 
            BlurringImage.getTheBlurredImage(DrawingVariables.currentScene.sceneBackgroundImg);
      }
      */
      return true;
    }
    else if(TransitionVariables.counter >= TransitionVariables.intervals)
    {      
      TransitionVariables.showTransition = false;
      TransitionVariables.counter = 1;
    }
    return false;
  }

  var transitionDown = function(currentImage, nextImage)
  {
    var dividerYOnCanvas = Math.floor(TransitionVariables.counter/TransitionVariables.intervals 
      * canvasGroup.temp.height);
    var dividerYOnCurrentDrawing = Math.floor(currentImage.height 
      * TransitionVariables.counter/TransitionVariables.intervals);
    var dividerYOnNextDrawing = Math.floor(nextImage.height 
      * TransitionVariables.counter/TransitionVariables.intervals);

    canvasGroupTempContext.drawImage(currentImage,
      0,0, currentImage.width, currentImage.height - dividerYOnCurrentDrawing,
      0,dividerYOnCanvas,canvasGroup.temp.width,canvasGroup.temp.height-dividerYOnCanvas);
    canvasGroupTempContext.drawImage(nextImage,
      0, nextImage.height - dividerYOnNextDrawing, nextImage.width, dividerYOnNextDrawing,
      0,0,canvasGroup.temp.width,dividerYOnCanvas);
  }

  var transitionUp = function(currentImage, nextImage)
  {
    var dividerYOnCanvas = Math.floor(TransitionVariables.counter/TransitionVariables.intervals 
      * canvasGroup.temp.height);
    var dividerYOnCurrentDrawing = Math.floor(currentImage.height 
      * TransitionVariables.counter/TransitionVariables.intervals);
    var dividerYOnNextDrawing = Math.floor(nextImage.height 
      * TransitionVariables.counter/TransitionVariables.intervals);

    canvasGroupTempContext.drawImage(currentImage,
      0, dividerYOnCurrentDrawing, currentImage.width,currentImage.height- dividerYOnCurrentDrawing,
      0,0,canvasGroup.temp.width, canvasGroup.temp.height - dividerYOnCanvas);
    canvasGroupTempContext.drawImage(nextImage,
      0,0, nextImage.width, dividerYOnNextDrawing,
      0,canvasGroup.temp.height-dividerYOnCanvas,canvasGroup.temp.width,dividerYOnCanvas);
  }

  var transitionLeft = function(currentImage, nextImage)
  {
    var dividerXOnCanvas = Math.floor(TransitionVariables.counter/TransitionVariables.intervals 
      * canvasGroup.temp.width);
    var dividerXOnCurrentDrawing = Math.floor(currentImage.width
      * TransitionVariables.counter/TransitionVariables.intervals);
    var dividerXOnNextDrawing = Math.floor(nextImage.width
      * TransitionVariables.counter/TransitionVariables.intervals);

    canvasGroupTempContext.drawImage(nextImage,
      0,0, dividerXOnNextDrawing, nextImage.height,
      canvasGroup.temp.width-dividerXOnCanvas,0,dividerXOnCanvas,canvasGroup.temp.height);
    canvasGroupTempContext.drawImage(currentImage,
      dividerXOnCurrentDrawing,0,currentImage.width - dividerXOnCurrentDrawing,currentImage.height,
      0,0,canvasGroup.temp.width-dividerXOnCanvas,canvasGroup.temp.height);
  }

  var transitionRight = function(currentImage, nextImage)
  {
    var dividerXOnCanvas = Math.floor(TransitionVariables.counter/TransitionVariables.intervals 
      * canvasGroup.temp.width);
    var dividerXOnCurrentDrawing = Math.floor(currentImage.width
      * TransitionVariables.counter/TransitionVariables.intervals);
    var dividerXOnNextDrawing = Math.floor(nextImage.width
      * TransitionVariables.counter/TransitionVariables.intervals);

    canvasGroupTempContext.drawImage(nextImage,
      nextImage.width-dividerXOnNextDrawing,0, dividerXOnNextDrawing, nextImage.height,
      0,0,dividerXOnCanvas,canvasGroup.temp.height);
    canvasGroupTempContext.drawImage(currentImage,
      0,0,currentImage.width - dividerXOnCurrentDrawing,currentImage.height,
      dividerXOnCanvas,0,canvasGroup.temp.width-dividerXOnCanvas,canvasGroup.temp.height);
  }

  var putBackground = function()
  {
    if(DrawingVariables.isInTransition)
    {
      if(!ifTransitionOver())
      {
        var currentImage = null;
        var nextImage = null;
        //TODO: Set the transition interval here for the timer
        if(TransitionVariables.showTransition)
        {
          currentImage = DrawingVariables.currentScene.sceneBackgroundImg;
          nextImage = TransitionVariables.transitionImage;
        }
        else
        {
          currentImage = TransitionVariables.transitionImage;
          nextImage = DrawingVariables.nextScene.sceneBackgroundImg;
        }

        if(TransitionVariables.direction == "down")
        {
          transitionDown(currentImage, nextImage);
        }
        else if(TransitionVariables.direction == "up")
        {      
          transitionUp(currentImage, nextImage);
        }
        else if(TransitionVariables.direction == "left")
        {      
          transitionLeft(currentImage, nextImage);
        }
        else if(TransitionVariables.direction == "right")
        {      
          transitionRight(currentImage, nextImage);
        }
      }
    }
    else
    {
      canvasGroupTempContext.drawImage(DrawingVariables.currentScene.sceneBackgroundImg,0,
          0,canvasGroup.temp.width,canvasGroup.temp.height);
    }
  }

  var drawingImageHelper = function(counter,alphaValue)
  {
    var minMax = DrawingVariables.canvas.blurringArrayMinMax[counter];
    var widthOfCut = minMax[1]-minMax[0];
    var heightOfCut = minMax[3]-minMax[2];
    canvasGroup.temp.width = canvasGroup.temp.width;
    canvasGroupTempContext.globalAlpha = 1 - (1/ConstantValues.n_revealInterval 
          * alphaValue);
    if(minMax.length > 3)
    {
        canvasGroupTempContext.drawImage(canvasGroup.blurringArray[counter],minMax[0],minMax[2],
          widthOfCut, heightOfCut,minMax[0],minMax[2],widthOfCut, heightOfCut);
    }
    canvasGroupTempContext.globalCompositeOperation = 'source-atop';
    putBackground();
    displayCurrentImages();
    canvasGroup.reveal.getContext('2d').drawImage(canvasGroup.temp,0,0);
  }
 
  canvasGroupDrawContext.fillStyle = "#000000";
  canvasGroupDrawContext.fillRect(0,0,canvasGroup.draw.width,canvasGroup.draw.height);
  
  // Checks to see if the current scene is blurred if it is then it paints the 
  // blurred background scene
  /*
  if(DrawingVariables.currentScene.sceneBlurred && !DrawingVariables.isInTransition)
  {
    canvasGroupDrawContext.drawImage(DrawingVariables.currentScene.sceneBlurredImg,
          0,0, canvasGroup.draw.width, canvasGroup.draw.height);
  }
  */
  
  if(isRevealingImage)
  {
    canvasGroup.reveal.width = canvasGroup.reveal.width;
 
    for(var counter = DrawingVariables.rotationValue + 1; counter < DrawingVariables.canvas.blurringArray.length; counter ++)
    {
      drawingImageHelper(counter, DrawingVariables.canvas.blurringArray.length - counter + DrawingVariables.rotationValue);
    }

    for(var counter = 0; counter <= DrawingVariables.rotationValue; counter ++)
    {
      drawingImageHelper(counter, DrawingVariables.rotationValue-counter);
    }

    setTimeout(0,canvasGroupDrawContext.drawImage(canvasGroup.reveal,0,0));
  }
}

var BlurStory = 
{
  canvasGroup : DrawingVariables.canvas,

  init: function()
  {
    if( ConstantValues.innerHeight/numRows < ConstantValues.innerWidth/numCols)
    {
      ConstantValues.canvasHeight = ConstantValues.innerHeight;
      ConstantValues.canvasWidth = ConstantValues.innerHeight/numRows*numCols;
    }
    else
    {
      ConstantValues.canvasHeight = ConstantValues.innerWidth/numCols*numRows;
      ConstantValues.canvasWidth = ConstantValues.innerWidth;
    }

    ConstantValues.setAllValues();

    this.canvasGroup.draw = $(ImageEnums.s_canvasName);
    this.canvasGroup.temp = document.createElement('canvas');
    this.canvasGroup.reveal = document.createElement('canvas');

    this.canvasGroup.draw.width = ConstantValues.canvasWidth;
    this.canvasGroup.draw.height = ConstantValues.canvasHeight;

    this.canvasGroup.temp.width = this.canvasGroup.draw.width;
    this.canvasGroup.temp.height = this.canvasGroup.draw.height;

    this.canvasGroup.reveal.width = this.canvasGroup.draw.width;
    this.canvasGroup.reveal.height = this.canvasGroup.draw.height;
  },

  startStory: function()
  {
    initHandlers();
    var timerOfReblur = setInterval(function()
    {
     RevealPartOfImage.rotateReveal();
    }, 100);

    for(var counter = 0; counter < this.canvasGroup.blurringArray.length; counter ++)
    {
      this.canvasGroup.blurringArray[counter] = document.createElement('canvas');
      this.canvasGroup.blurringArray[counter].width = this.canvasGroup.draw.width;
      this.canvasGroup.blurringArray[counter].height = this.canvasGroup.draw.height;
      this.canvasGroup.blurringArrayMinMax[counter] = [this.canvasGroup.draw.width,0,
          this.canvasGroup.draw.height,0];
    }
    
    LoggingData.sceneChange(DrawingVariables.currentScene.sceneName);
    
    /*
    if(DrawingVariables.currentScene.sceneBlurred)
    {
      DrawingVariables.currentScene.sceneBlurredImg = 
          BlurringImage.getTheBlurredImage(DrawingVariables.currentScene.sceneBackgroundImg);
    }
    */

    BlurStory.turnOnAllCurrentLogic();
 
    paintImage(false);
  },

  checkIfHiddenImagesVisible : function()
  {
    for(var logicCounter = 0; logicCounter < ListOfLogics.length; logicCounter ++)
    {
      var currentLogic = ListOfLogics[logicCounter];
      if(currentLogic.isActive)
      {
        if(currentLogic.triggerActivated)
        {
          this.checkEachLogic(currentLogic);
        }
        else
        {
          if(this.ifVisibleRegion(currentLogic.triggerLogicLocation[0],
              currentLogic.triggerLogicLocation[1],
              DrawingVariables.currentX, DrawingVariables.currentY) && currentLogic.isActive)
          {
            currentLogic.triggerActivated= true;
          }
        }
      }
    }
  },

  checkEachLogic : function(HiddenImageLogic)
  {    
    var goToNextStep = true;
    if (typeof(HiddenImageLogic.listOfCurrentImages) == 'undefined')
    {
      return;
    }
    else
    {
      for(var counter =0; counter < HiddenImageLogic.listOfCurrentImages.length; counter ++)
      {
        if(!this.checkNextLogic(HiddenImageLogic.listOfCurrentImages[counter],counter, HiddenImageLogic))
        {
          goToNextStep = false;
        }
      }
      if(goToNextStep)
      {
        var anImageVisible = false;
        for(var counter =0; counter < HiddenImageLogic.listOfCurrentImages.length; counter ++)
        {
          if(this.ifVisibleRegionDisappearing(HiddenImageLogic.listOfCurrentImages[counter].hiddenImageLocationX,
            HiddenImageLogic.listOfCurrentImages[counter].hiddenImageLocationY,
            DrawingVariables.currentX, DrawingVariables.currentY))
          {
            anImageVisible = true;
          }
        }
  
        for(var logicCounter = 0; logicCounter < ListOfLogics.length; logicCounter++)
        {
          if( this.logicMatch(HiddenImageLogic.listOfNextLogicOff, ListOfLogics[logicCounter].logicId) )
          {
            for(var counter =0; counter < ListOfLogics[logicCounter].listOfCurrentImages.length; counter ++)
            {
              if(this.ifVisibleRegionDisappearing(ListOfLogics[logicCounter].listOfCurrentImages[counter].hiddenImageLocationX,
                  ListOfLogics[logicCounter].listOfCurrentImages[counter].hiddenImageLocationY,
                  DrawingVariables.currentX, DrawingVariables.currentY))
              {
                anImageVisible = true;
              }
            }
          }
        }

        if(HiddenImageLogic.nextScene)
        {
          anImageVisible = false;
        }

        //If the image is not visible and it also is not the scene changer make sure image doesn't change
        if(!anImageVisible && !TransitionVariables.currentlyChangingScene 
                && this.checkIfDependenciesFulfilled(HiddenImageLogic) )
        {
          if(HiddenImageLogic.nextScene)
          {
            setTimeout( function() { BlurStory.nextSteps(HiddenImageLogic) }, 2000); 
            TransitionVariables.currentlyChangingScene = true;
          }
          else
          {
            this.nextSteps(HiddenImageLogic);
          }
        }
      }
    }
  },

  checkIfDependenciesFulfilled : function(currentImageLogic)
  {
    for(var logicCounter = 0; logicCounter < ListOfLogics.length; logicCounter++)
    {
      if( this.logicMatch(currentImageLogic.listOfDependentLogic, ListOfLogics[logicCounter].logicId) )
      {
        if(!ListOfLogics[logicCounter].isActive)
        {
          return false;
        }
      }
    }
    return true;
  },

  checkNextLogic : function(checkingImage, currentImageIdx, HiddenImageLogic)
  {
    if(this.ifVisibleRegion(checkingImage.hiddenImageLocationX,checkingImage.hiddenImageLocationY
          ,DrawingVariables.currentX, DrawingVariables.currentY))
    {
      var correctOrder = true;
      if(HiddenImageLogic.orderImportant)
      {
        for(var counter = 0; counter < currentImageIdx; counter ++)
        {
          //Checks to see if anything before it is false, as that means it was seen out of order
          if(!HiddenImageLogic.listOfCurrentImages[counter].hiddenImageSeen)
          {
            correctOrder = false;
            break;
          }
        }
      }
      if(correctOrder)
      {
        checkingImage.hiddenImageSeen = true;
        return true;
      }
      else
      {
        for(var counter =0; counter < HiddenImageLogic.listOfCurrentImages.length; counter ++)
        {
          HiddenImageLogic.listOfCurrentImages[counter].hiddenImageSeen = false;
        }
        return false;
      }
    }
    else
    {
        return checkingImage.hiddenImageSeen;
    }
    return false;
  },

  ifVisibleRegion : function(hiddenX, hiddenY, cursorX, cursorY)
  {
    var xValue = (hiddenX * ConstantValues.n_widthOfGrid) + ConstantValues.n_widthOfGrid/2 - cursorX;
    var yValue = (hiddenY * ConstantValues.n_heightOfGrid) + ConstantValues.n_heightOfGrid/2 - cursorY;
    if( xValue * xValue + yValue * yValue < (DrawingVariables.n_widthOfReveal * DrawingVariables.n_widthOfReveal) * 0.5)
    {
      return true;
    }
    return false;
  },

  ifVisibleRegionDisappearing : function(hiddenX, hiddenY, cursorX, cursorY)
  {
    var xValue = (hiddenX * ConstantValues.n_widthOfGrid) + ConstantValues.n_widthOfGrid/2 - cursorX;
    var yValue = (hiddenY * ConstantValues.n_heightOfGrid) + ConstantValues.n_heightOfGrid/2 - cursorY;
    if( xValue * xValue + yValue * yValue < (DrawingVariables.n_widthOfReveal * DrawingVariables.n_widthOfReveal * 1.1))
    {
      return true;
    }
    return false;
  },

  ifVisibleRegionAppearing : function(hiddenX, hiddenY, cursorX, cursorY)
  {
    var xValue = (hiddenX * ConstantValues.n_widthOfGrid) + ConstantValues.n_widthOfGrid/2 - cursorX;
    var yValue = (hiddenY * ConstantValues.n_heightOfGrid) + ConstantValues.n_heightOfGrid/2 - cursorY;
    if( xValue * xValue + yValue * yValue < (DrawingVariables.n_widthOfReveal * DrawingVariables.n_widthOfReveal * 2.5))
    {
      return true;
    }
    return false;
  },

  nextSteps : function(HiddenImageLogic)
  {
    HiddenImageLogic.isActive = false;  
    HiddenImageLogic.triggerActivated = true; //false

    //Turn all the image seen as false
    for(var counter =0; counter < HiddenImageLogic.listOfCurrentImages.length; counter ++)
    {
          HiddenImageLogic.listOfCurrentImages[counter].hiddenImageSeen = false;
    }

    for(var logicCounter = 0; logicCounter < ListOfLogics.length; logicCounter++)
    {
      if( this.logicMatch(HiddenImageLogic.listOfNextLogicOn, ListOfLogics[logicCounter].logicId) )
      {
        ListOfLogics[logicCounter].isActive = true;
        StoryAudio.changeAudio(ListOfLogics[logicCounter].audioForLogic);
      }
      else if( this.logicMatch(HiddenImageLogic.listOfNextLogicOff, ListOfLogics[logicCounter].logicId) )
      {
        ListOfLogics[logicCounter].isActive = false;
        //Again make sure all image is set to seen as false, so it doesn't overlap
        for(var counter =0; counter < ListOfLogics[logicCounter].listOfCurrentImages.length; counter ++)
        {
          ListOfLogics[logicCounter].listOfCurrentImages[counter].hiddenImageSeen = false;
        }
      }
    }
    if(HiddenImageLogic.nextScene)
    {
      if(HiddenImageLogic.nextScene == "END")
      {
        alert("Story ended");
      }
      var nextSceneName = HiddenImageLogic.nextScene;
      DrawingVariables.nextScene = DrawingVariables.mapOfScenes[nextSceneName];
      DrawingVariables.isInTransition = true;
      TransitionVariables.transitionImage = HiddenImageLogic.transitionImage;
      TransitionVariables.direction = HiddenImageLogic.transitionDirection;
      TransitionVariables.timer = setInterval(function() {TransitionVariables.counter += 1; },
          TransitionVariables.timerTime);

      this.turnOffAllCurrentLogic();
    }
  },

  logicMatch: function(listOfLogics, logicId)
  {
    //console.log(listOfLogics);
    for(var counter = 0; counter < listOfLogics.length; counter ++)
    {
      //console.log(listOfLogics[counter]);
      //console.log('Name:' + logicId);
      if(listOfLogics[counter] == logicId)
      {
        //console.log("Found:" + listOfLogics[counter]);
        return true;
      }
    }
    return false;
  },

  turnOnAllCurrentLogic : function()
  {
    TransitionVariables.currentlyChangingScene = false;
    for(var logicCounter = 0; logicCounter < ListOfLogics.length; logicCounter++)
    {
      if(ListOfLogics[logicCounter].sceneNumber == DrawingVariables.currentScene.sceneNumber &&
          ListOfLogics[logicCounter].initiallyActive)
      {
        ListOfLogics[logicCounter].isActive = true;
      }
    }
  },

  turnOffAllCurrentLogic : function()
  {
    for(var logicCounter = 0; logicCounter < ListOfLogics.length; logicCounter++)
    {
      if(ListOfLogics[logicCounter].sceneNumber <= DrawingVariables.currentScene.sceneNumber)
      {
        ListOfLogics[logicCounter].isActive = false;
        for(var counter =0; counter < ListOfLogics[logicCounter].listOfCurrentImages.length; counter ++)
        {
          ListOfLogics[logicCounter].listOfCurrentImages[counter].hiddenImageSeen = false;
        }

      }
    }
  }
}

var RevealPartOfImage = 
{
  unBlurDraggedArea : function(x, y, move, theCanvas)
  {
    var contextOfCanvas = theCanvas.getContext('2d');
    contextOfCanvas.lineWidth = DrawingVariables.n_widthOfReveal;
    contextOfCanvas.lineCap = contextOfCanvas.lineJoin = 'round';
    contextOfCanvas.strokeStyle = '#000000';
    if(!move)
    {
      contextOfCanvas.beginPath();
      contextOfCanvas.lineTo(x+0.01, y);
    }
    contextOfCanvas.lineTo(x,y);
    contextOfCanvas.stroke();

    var minMax = DrawingVariables.canvas.blurringArrayMinMax[DrawingVariables.rotationValue];

    minMax = [Math.min(minMax[0], Math.max(0,x-DrawingVariables.n_widthOfReveal)), 
       Math.max(minMax[1], Math.min(theCanvas.width,x+DrawingVariables.n_widthOfReveal)),
       Math.min(minMax[2], Math.max(0,y-DrawingVariables.n_widthOfReveal)), 
       Math.max(minMax[3], Math.min(theCanvas.height,y+DrawingVariables.n_widthOfReveal))];

    DrawingVariables.canvas.blurringArrayMinMax[DrawingVariables.rotationValue] = minMax;
 
    paintImage(true);
  },

  rotateReveal : function()
  {
    var canvasGroup = DrawingVariables.canvas;

    if(Math.abs(DrawingVariables.currentX - DrawingVariables.previousX) > 1 ||
        Math.abs(DrawingVariables.currentY - DrawingVariables.previousY) > 1)
    {
      this.increaseRevealSize();
      DrawingVariables.rotationValue = (DrawingVariables.rotationValue + 1) 
      % canvasGroup.blurringArray.length;
      canvasGroup.blurringArray[DrawingVariables.rotationValue].width = canvasGroup.draw.width; 
      
      if(DrawingVariables.currentX != 0 && DrawingVariables.currentY != 0)
      {
        RevealPartOfImage.unBlurDraggedArea(DrawingVariables.currentX,DrawingVariables.currentY,false,
            DrawingVariables.canvas.blurringArray[DrawingVariables.rotationValue]);
      }
      BlurStory.checkIfHiddenImagesVisible();
      paintImage(true);
    }
    else if(DrawingVariables.currentX != 0 && DrawingVariables.currentY != 0)
    {    
      this.increaseRevealSize();
      RevealPartOfImage.unBlurDraggedArea(DrawingVariables.currentX,DrawingVariables.currentY,false,
          DrawingVariables.canvas.blurringArray[DrawingVariables.rotationValue]);
      //Checks to see if the hiddenImage is now Visible when user not moving
      BlurStory.checkIfHiddenImagesVisible();
      paintImage(true);
    }
    else
    {
      DrawingVariables.rotationValue = (DrawingVariables.rotationValue + 1) 
      % canvasGroup.blurringArray.length;
      //canvasGroup.blurringArray[DrawingVariables.rotationValue].width = canvasGroup.draw.width; 
      paintImage(true);
    }
    DrawingVariables.previousX = DrawingVariables.currentX;
    DrawingVariables.previousY = DrawingVariables.currentY;
  },

  increaseRevealSize : function()
  {
    if(DrawingVariables.n_widthOfReveal < ConstantValues.n_widthOfRevealMax)
    {
      DrawingVariables.n_widthOfReveal = (DrawingVariables.n_widthOfReveal+30)*2;
      if(DrawingVariables.n_widthOfReveal > ConstantValues.n_widthOfRevealMax)
        DrawingVariables.n_widthOfReveal = ConstantValues.n_widthOfRevealMax;
    }
    else
    {
      DrawingVariables.n_widthOfReveal = ConstantValues.n_widthOfRevealMax;
    }
  }
}

var $ = function(s_idName)
{
  return document.getElementById(s_idName);
}

function errorLoggingOn()
{
  window.onerror = function(message, url, lineNumber) {
    console.log("Error: "+message+" in " + url + " at line " + lineNumber);
  }
}

var LoadingStory = 
{
  startLoading : function()
  {
    BlurStory.init();
    this.fadeInStory(1.0);
  },

  fadeInStory : function(opacityLevel)
  {
    if(opacityLevel >= 0)
    {
      var canvasGroup = DrawingVariables.canvas;
      var canvasGroupDrawContext = canvasGroup.draw.getContext('2d');

      canvasGroupDrawContext.drawImage(DrawingVariables.currentScene.sceneBackgroundImg,0,
          0,canvasGroup.draw.width,canvasGroup.draw.height);

      canvasGroupDrawContext.fillStyle="rgba(0,0,0,"+ opacityLevel +")";
      canvasGroupDrawContext.fillRect(0,0,canvasGroup.draw.width, canvasGroup.draw.height);
      setTimeout(function() {LoadingStory.fadeInStory(opacityLevel-0.1)}, 100);
    }
    else
    {
      setTimeout(function() {LoadingStory.fadeOutStory(0.0)}, 1000);
    }
  },

  fadeOutStory : function(opacityLevel)
  {
    if(opacityLevel <= 1)
    {
      var canvasGroup = DrawingVariables.canvas;
      var canvasGroupDrawContext = canvasGroup.draw.getContext('2d');

      canvasGroupDrawContext.drawImage(DrawingVariables.currentScene.sceneBackgroundImg,0,
          0,canvasGroup.draw.width,canvasGroup.draw.height);

      canvasGroupDrawContext.fillStyle="rgba(0,0,0,"+ opacityLevel +")";
      canvasGroupDrawContext.fillRect(0,0,canvasGroup.draw.width, canvasGroup.draw.height);
      setTimeout(function() {LoadingStory.fadeOutStory(opacityLevel+0.1)}, 100);
    }
    else
    {
      BlurStory.startStory();
    }
  }
}

function initImages()
{
  DrawingVariables.currentScene.sceneBackgroundImg.onload = function()
  {
    LoadingStory.startLoading();
  };
}

function main() 
{
  initStory();
  initImages();

  var timerOfSendingData = setInterval(function()
  {
     LoggingData.sendData();
  }, 10000);
}

main();
